<?php

class Param {
	
	//---------------------------------------------------------
	//  コントロール設定
	//---------------------------------------------------------
	
	public static function control() {
		
		// コントロール設定を返す
		return [true, false, 'Header', 'Footer'];
		
	}
	
	//---------------------------------------------------------
	//  月間パラメータ統計生成
	//---------------------------------------------------------
	
	public static function execute() {
		
		// DBクラスを取得
		$db = $GLOBALS['object']['db'];
		
		// テンプレートクラスを取得
		$tmpl = $GLOBALS['object']['tmpl'];
		
		// DBのサフィックスを取得
		$suffix = $GLOBALS['suffix'];
		
		////////////////////////////////////////////////////////////
		
		// アクション名を取得
		$act = $GLOBALS['args']['act'];
		
		// 項目種別を取得
		$param = $GLOBALS['args'][1];
		
		// フィルター設定を取得
		$opt = $GLOBALS['args']['opt'];
		
		// ピックアップ項目を取得
		$pickup = $GLOBALS['args']['pickup'];
		
		// 年を取得
		$y = $GLOBALS['args']['y'];
		
		// 月を取得
		$m = $GLOBALS['args']['m'];
		
		// 年を取得
		$ly = $GLOBALS['args']['ly'];
		
		// 月を取得
		$lm = $GLOBALS['args']['lm'];
		
		// 全件表示フラグを取得
		$all = $GLOBALS['args']['all'];
		
		// 最大表示件数を取得
		$paramViewLimit = $GLOBALS['config']['content']['paramViewLimit'];
		
		////////////////////////////////////////////////////////////
		
		// ジャンプパスを定数に設定
		define('JUMP_PATH', PATH . '/jump/');
		
		// 最大表示文字数を定数に設定
		define('MAX_LEN', 50);
		
		////////////////////////////////////////////////////////////
		
		// DB名を設定
		$tmDB = 'access_' . $y . '_' . $m . $suffix;
		
		// DB名を設定
		$lmDB = 'access_' . $ly . '_' . $lm . $suffix;
		
		// DBが存在しない時は終了
		if (!$db->exists($tmDB)) {
			return;
		}
		
		////////////////////////////////////////////////////////////
		
		// 別名で変数を保持
		$allViewOpt = $opt;
		
		// ピックアップフィルターの時は追記
		if ($opt === 'pickup') {
			$allViewOpt .= '/' . $pickup;
		}
		
		// フィルターが無い時
		if (!$opt || $opt === 'none') {
			$opt = '';
			$allViewOpt = 'none';
		}
		
		// 全件表示用リンクを設定
		$allViewPath = PATH . '/param/' . $param . '/' . $y . '/' . $m . '/' . $allViewOpt . '/all/';
		
		////////////////////////////////////////////////////////////
		
		// テーブル名を取得
		$paramTable = $GLOBALS['config']['table']['param'];
		
		// ヘッダー,メイン,フッター テンプレートを取得
		[$head, $body, $foot, $allView] = $tmpl->read('param.htm');
		
		// ヘッダーテンプレートを出力
		$tmpl->show($head);
		
		////////////////////////////////////////////////////////////
		
		// 変数を初期化
		$opt2 = '';
		$from = '';
		$where = "type = '$param'";
		$limit = '';
		$slash = '/';
		$uaType = '';
		$column1 = 'sum(count) as sum, count(distinct value) as rows';
		$column2 = '';
		$replace = '';
		
		// 簡易検索用リンクを設定
		$searchPath = PATH . '/search/' . $param . '/' . $y . '/' . $m . '/xx';
		
		////////////////////////////////////////////////////////////
		
		// 有無フィルターの時（リンク元）
		if ($opt === 'exists') {
			$replace = 'replaceOptExists';
		}
		
		// ドメインフィルターの時（リンク元）
		elseif ($opt === 'domain') {
			[$replace, $column2, $from, $where, $opt] = self::domain($db);
		}
		
		// 検索フィルターの時（リンク元）
		elseif ($opt === 'search') {
			[$replace, $column2, $from, $where, $opt] = self::search($db);
		}
		
		// ページ、リンク先、リンク元の時
		elseif ($param === 'page' || $param === 'click' || $param === 'referrer') {
			[$replace, $column2, $from, $where, $param, $opt, $slash] = self::page($db, $param, $opt);
		}
		
		// 統合フィルターの時（OS、UA、端末機種）
		elseif ($opt === 'group') {
			[$replace, $where] = self::group($act, $param, $where, $y, $m);
		}
		
		// 検索キーワードの時
		elseif ($param === 'search_word' || $param === 'search_words') {
			$replace = 'replaceSearchWord';
		}
		
		// 訪問回数の時
		elseif ($param === 'visit_count') {
			$replace = ($opt === 'repeat') ? 'replaceRepeat' : 'replaceVisit';
		}
		
		// OSの時
		elseif ($param === 'os') {
			[$replace, $where, $opt] = self::os($opt, $pickup);
		}
		
		// UAの時
		elseif ($param === 'ua') {
			[$replace, $param, $where, $opt, $uaType, $pickup] = self::ua($opt, $pickup);
		}
		
		// ホストドメインの時
		elseif ($param === 'host_domain') {
			[$replace, $where, $opt] = self::hostDomain($opt);
		}
		
		// 端末機種の時
		elseif ($param === 'device') {
			
			// iniファイルを読み込み
			self::device();
			
			// オプションを設定
			if (!$opt) {
				$opt = 'model';
			}
			
		}
		
		////////////////////////////////////////////////////////////
		
		// 全件表示の時はフラグをtrueに設定
		$isShowAll = ($pickup === 'all' || $all);
		
		// limit句を設定
		if (!$isShowAll && !$opt) {
			$limit = "limit $paramViewLimit";
		}
		
		////////////////////////////////////////////////////////////
		
		// 前月データ配列
		$lmData = [];
		
		// 前月DBが存在する時
		if ($db->exists($lmDB)) {
			
			// DBに追加接続
			$db->attach($lmDB, 'lm');
			
			// クエリーを作成
			$query1 = "select $column1 from $paramTable $from where $where;";
			
			// クエリーを実行
			$rec1 = $db->queryFetch($query1);
			
			// 総カウント数を取得
			$lmTotalCnt = $rec1['sum'];
			
			// 総件数を取得
			$lmAllRows = $rec1['rows'];
			
			// クエリーを作成
			$query2 = "select value, count $column2 from $paramTable $from where $where order by count desc;";
			
			// クエリーを実行
			$results2 = $db->query($query2);
			
			// フィルター設定が存在する時
			if ($opt) {
				[$lmOptData, $lmTotalCnt, $lmAllRows] = self::optFilter($db, $param, $opt, $results2, $lmTotalCnt, $paramTable);
			}
			
			////////////////////////////////////////////////////////////
			
			// 先月のレコードデータ集計ループ
			for ($i = 1; ; ++$i) {
				
				// フィルターが存在しない時
				if (!$opt) {
					
					// データを取得
					$rec = $db->fetch($results2);
					
					// データが無い時はループ終了
					if (!$rec) {
						break;
					}
					
					// 項目名を取得
					$lmValue = $rec['value'];
					
					// カウント数を取得
					$lmCount = $rec['count'];
					
				}
				
				// フィルターが存在する時
				else {
					
					// データが無い時はループ終了
					if ($i > $lmAllRows) {
						break;
					}
					
					// 項目名を取得
					$lmValue = key($lmOptData);
					
					// カウント数を取得
					$lmCount = $lmOptData[$lmValue];
					
					// 内部ポインタを進める
					next($lmOptData);
					
				}
				
				// 先月の順位を連想配列に設定
				$lmData[$lmValue]['rank'] = $i;
				
				// 先月のパーセンテージを連想配列に設定
				$lmData[$lmValue]['per'] = number_format($lmCount / $lmTotalCnt * 100, 1);
				
			}
			
			// DB追加接続を解除
			$db->detach('lm');
			
		}
		
		////////////////////////////////////////////////////////////
		
		// DBに追加接続
		$db->attach($tmDB, 'tm');
		
		// クエリーを作成
		$query3 = "select $column1 from $paramTable $from where $where;";
		
		// クエリーを実行
		$rec3 = $db->queryFetch($query3);
		
		// 総カウント数を取得
		$totalCount = $rec3['sum'];
		
		// 総件数を取得
		$allRows = $rec3['rows'];
		
		// クエリーを作成
		$query4 = "select value, count $column2 from $paramTable $from where $where order by count desc $limit;";
		
		// クエリーを実行
		$results4 = $db->query($query4);
		
		// フィルター設定が存在する時
		if ($opt) {
			
			// フィルタリングしたデータを取得
			[$optCounts, $totalCount, $allRows] = self::optFilter($db, $param, $opt, $results4, $totalCount, $paramTable);
			
			// パスに追記
			$opt2 = '/';
			
		}
		
		// 携帯フィルターの時はパスに追記
		elseif ($uaType) {
			$opt2 = $uaType . '/';
		}
		
		////////////////////////////////////////////////////////////
		
		// 制限表示の時
		if (!$isShowAll) {
			$limitCount = ($allRows > $paramViewLimit) ? $paramViewLimit : $allRows;
		}
		
		// 全件表示の時
		else {
			$limitCount = $allRows;
		}
		
		////////////////////////////////////////////////////////////
		
		// レコードデータ表示ループ
		for ($i = 1; ; ++$i) {
			
			// フィルターが存在しない時
			if (!$opt) {
				
				// データを取得
				$vars = $db->fetch($results4);
				
				// データが無い時はループ終了
				if (!$vars) {
					break;
				}
				
			}
			
			// フィルターが存在する時
			else {
				
				// データが無い時はループ終了
				if ($i > $limitCount) {
					break;
				}
				
				// 配列のキーを取得
				$key = key($optCounts);
				
				// 項目名を取得
				$vars['value'] = $key;
				
				// カウント数を取得
				$vars['count'] = $optCounts[$key];
				
				// 配列のポインタを進める
				next($optCounts);
				
			}
			
			// 項目名を取得
			$value = $vars['value'];
			
			// 表示文字列を置換
			if ($replace) {
				$vars['value'] = self::$replace($vars, $param);
			}
			
			// 色分け用class属性を設定
			$vars['tr'] = ($i % 2 === 0) ? 2 : 1;
			
			// パーセンテージを算出
			$vars['per'] = number_format($vars['count'] / $totalCount * 100, 1);
			
			// 0.1未満の時は「0.1」を設定
			if ($vars['per'] === 0) {
				$vars['per'] = 0.1;
			}
			
			// 簡易検索リンクを設定
			$vars['count'] = '<a href="' . $searchPath . '/' . $value . $slash . $opt . $opt2 . '">' . $vars['count'] . '</a>';
			
			// 順位を設定
			$vars['rank'] = $i;
			
			////////////////////////////////////////////////////////////
			
			// 先月のデータが存在する時
			if (isset($lmData[$value])) {
				
				// 先月の順位を設定
				$vars['lmRank'] = $lmData[$value]['rank'];
				
				// 先月のパーセンテージ増減を算出
				$vars['lmPer'] = number_format($vars['per'] - $lmData[$value]['per'], 1);
				
				// 先月のパーセンテージ増減を整形
				if ($vars['lmPer'] > 0) {
					$vars['lmPer'] = '+' . $vars['lmPer'];
					$vars['upDown'] = 'up';
				}
				
				// 増減が無い時
				elseif ($vars['lmPer'] === 0.0) {
					$vars['lmPer'] = '+' . $vars['lmPer'];
					$vars['upDown'] = 'even';
				}
				
				// 先月以下の時
				else {
					$vars['upDown'] = 'down';
				}
				
				// 先月より順位が上の時
				if ($vars['rank'] < $vars['lmRank']) {
					$img = 'up';
				}
				
				// 先月より順位が下の時
				elseif ($vars['rank'] > $vars['lmRank']) {
					$img = 'down';
				}
				
				// 先月と同じ順位の時
				else {
					$img = 'even';
				}
				
			}
			
			// 先月のデータが存在しない時
			else {
				
				// 先月の順位に「-」を設定
				$vars['lmRank'] = '－';
				
				// 今月のパーセンテージを設定
				$vars['lmPer'] = '+' . $vars['per'];
				
				// 新規データを設定
				$vars['upDown'] = 'new';
				
				// 新規データを設定
				$img = 'new';
				
			}
			
			////////////////////////////////////////////////////////////
			
			// パーセンテージを整形
			$vars['per'] .= '%';
			
			// パーセンテージ増減を整形
			$vars['lmPer'] .= '%&nbsp;';
			
			// 順位変動<img>を整形
			$vars['lmImg'] = '<img src="' . PATH_DIR . '/templates/img/lm/' . $img . '.gif" width="15" height="15">';
			
			// メインテンプレートを出力
			$tmpl->show($body, $vars);
			
		}
		
		////////////////////////////////////////////////////////////
		
		// フッターテンプレートを出力
		$tmpl->show($foot);
		
		// 表示制限がある時
		if (!$isShowAll && $allRows > $paramViewLimit) {
			
			// 全件表示リンクをテンプレート変数に設定
			$allVars['link'] = $allViewPath;
			
			// ナビテンプレートを出力
			$GLOBALS['args']['contentAll'] = $tmpl->res($allView, $allVars);
			
		}
		
	}
	
	//---------------------------------------------------------
	//  ドメインフィルター（リンク元）
	//---------------------------------------------------------
	
	public static function domain($db) {
		
		// テーブル名を取得
		$refTable = $GLOBALS['config']['table']['referrer'];
		
		// テーブル名を設定
		$from = ', ' . $refTable;
		
		// 置換メソッド名を設定
		$replace = 'replaceOptDomain';
		
		// カラム名を設定
		$column2 = ', url as value';
		
		// 検索条件を設定
		$where = "type = 'referrer' and value = id";
		
		// オプションを再設定
		$opt = 'domain';
		
		// メソッド名、カラム名、from句、where句を返す
		return [$replace, $column2, $from, $where, $opt];
		
	}
	
	//---------------------------------------------------------
	//  検索フィルター（リンク元）
	//---------------------------------------------------------
	
	public static function search($db) {
		
		// テーブル名を取得
		$refTable = $GLOBALS['config']['table']['referrer'];
		
		// テーブル名を設定
		$from = ', ' . $refTable;
		
		// 置換メソッド名を設定
		$replace = 'replacePage';
		
		// カラム名を設定
		$column2 = ', url, title';
		
		// 検索条件を設定
		$where = "type = 'referrer' and value = id and (url like '%google%'";
		
		// 検索エンジンのドメイン配列
		$domains = [
			'yahoo',
			'excite',
			'nifty',
			'biglobe',
			'msn',
			'goo',
			'infoseek',
			'ocn',
			'baidu'
		];
		
		// 配列を読み込むループ
		foreach ($domains as $domain) {
			$where .= " or url like '%" . $domain . "%'";
		}
		
		// 検索条件に追記
		$where .= " or title like '%検索%')";
		
		// オプションを再設定
		$opt = '';
		
		// メソッド名、カラム名、from句、where句を返す
		return [$replace, $column2, $from, $where, $opt];
		
	}
	
	//---------------------------------------------------------
	//  ページ、リンク元、リンク先
	//---------------------------------------------------------
	
	public static function page($db, $param, $opt) {
		
		// テーブル名を取得
		$table = $GLOBALS['config']['table'][$param];
		
		// 置換メソッド名を設定
		$replace = 'replacePage';
		
		// 変数を初期化
		$title = 'title';
		$slash = '/';
		
		// テーブル名を設定
		$from = ', ' . $table;
		
		// 検索条件を設定
		$where = "type = '$param' and value = id";
		
		// URLフィルターの時
		if ($opt == 'url') {
			
			// カラム名を設定
			$title = 'url as title';
			
			// 置換メソッド名を設定
			$replace = 'replaceOptURL';
			
		}
		
		// ディレクトリフィルターの時
		elseif ($opt === 'dir') {
			
			// 置換メソッド名を設定
			$replace = 'replaceOptDir';
			
			// スラッシュを削除
			$slash = '';
			
		}
		
		// ファイルリンク/外部リンクの時
		elseif ($param === 'click') {
			
			// ドメイン名配列を取得
			if ($opt) {
				$domains = self::getSelfDomains($db);
			}
			
			// ファイルリンクの時
			if ($opt === 'file') {
				$where .= " and (url like '" . implode("%' or url like '", $domains) . "%')";
			}
			
			// 外部リンクの時
			elseif ($opt === 'out') {
				$where .= " and (url not like '" . implode("%' and url not like '", $domains) . "%')";
			}
			
		}
		
		////////////////////////////////////////////////////////////
		
		// カラム名を設定
		$column2 = ", $title, url";
		
		// フィルターをリセット
		if ($opt !== 'dir') {
			$opt = '';
		}
		
		// メソッド名、カラム名、from句、where句を返す
		return [$replace, $column2, $from, $where, $param, $opt, $slash];
		
	}
	
	//---------------------------------------------------------
	//  OS
	//---------------------------------------------------------
	
	public static function os($opt, $pickup) {
		
		// iniファイルをパース
		$GLOBALS['name'] = parse_ini_file(WORK_DIR . '/templates/ini/os.ini');
		
		// 変数を初期化
		$where = "type = 'os'";
		
		// PCフィルターの時
		if ($opt === 'pc') {
			$where .= " and (value not like 'iOS%' and value not like 'Android%' and value not like 'Windows Mobile%' and value not like 'Windows Phone%')";
		}
		
		// 携帯フィルターの時
		elseif ($opt === 'mobile') {
			$where .= " and (value like 'iOS%' or value like 'Android%' or value like 'Windows Mobile%' or value like 'Windows Phone%')";
		}
		
		// ピックアップフィルター（Linux）の時
		elseif ($pickup === 'Linux') {
			$where .= " and (value like '%Linux%' or value = 'Fedora' or value = 'Ubuntu' or value = 'CentOS')";
		}
		
		// ピックアップフィルターの時
		elseif ($opt === 'pickup') {
			$where .= " and value like '$pickup%'";
		}
		
		// 置換メソッド名を設定
		$replace = 'replaceOS';
		
		// フィルターをリセット
		$opt = '';
		
		// 検索条件を返す
		return [$replace, $where, $opt];
		
	}
	
	//---------------------------------------------------------
	//  UA
	//---------------------------------------------------------
	
	public static function ua($opt, $pickup) {
		
		// 変数をを初期化
		$param = 'ua';
		$where = "type = 'ua'";
		$replace = '';
		
		// フィルターを別名で保持
		$uaType = $opt;
		
		// フィルターがない時
		if (!$opt) {
			
			// 検索条件を設定
			$where .= " or type = 'mobile' or type = 'game'";
			
		}
		
		// ロボットフィルターの時
		elseif ($opt === 'robot') {
			
			// パラメータ名を設定
			$param = 'robot';
			
			// 検索条件を設定
			$where = "type = 'robot'";
			
			// 置換メソッド名を設定
			$replace = 'replaceOptRobot';
			
		}
		
		// 携帯フィルターの時
		elseif ($opt === 'mobile') {
			
			// パラメータ名を設定
			$param = 'mobile';
			
			// 検索条件を設定
			$where = "type = 'mobile'";
			
		}
		
		// ピックアップフィルターの時
		elseif ($opt === 'pickup') {
			
			// 検索条件を設定
			$where = "(type = 'ua' or type = 'mobile' or type = 'game') and value like '$pickup%'";
			
		}
		
		// フィルターをリセット
		$opt = '';
		
		// メソッド名、カラム名を返す
		return [$replace, $param, $where, $opt, $uaType, $pickup];
		
	}
	
	//---------------------------------------------------------
	//  端末機種
	//---------------------------------------------------------
	
	public static function device() {
		
		// iniファイルをパース
		$GLOBALS['name'] = parse_ini_file(WORK_DIR . '/templates/ini/device.ini');
		
	}
	
	//---------------------------------------------------------
	//  ホストドメイン
	//---------------------------------------------------------
	
	public static function hostDomain($opt) {
		
		// 検索条件を設定
		$where = "type = 'host_domain'";
		
		// 置換メソッドを設定
		$replace = ($opt !== 'world') ? 'replaceHostDomain' : 'replaceWorld';
		
		// 外国フィルターの時
		if ($opt === 'world') {
			$where .= " and value not like '%.jp' and value not like '%.com' and value not like '%.net' and value != 'unknown'";
		}
		
		// 学校・会社フィルターの時
		elseif ($opt && $opt !== 'world') {
			$where .= " and value like '%.$opt.%'";
		}
		
		// 組織・国名を取得
		$ini = ($opt === 'world') ? 'country.ini' : 'isp.ini';
		
		// 組織・国名設定ファイルを解析
		$GLOBALS['name'] = parse_ini_file(WORK_DIR . '/templates/ini/' . $ini);
		
		// フィルターをリセット
		$opt = '';
		
		// メソッド名、where句を返す
		return [$replace, $where, $opt];
		
	}
	
	//---------------------------------------------------------
	//  統合オプション
	//---------------------------------------------------------
	
	public static function group($act, $param, $where, $y, $m) {
		
		// 置換メソッド名を設定
		$replace = 'replaceGroup';
		
		// 定数を設定
		define('ARRANGE_PATH', PATH . '/' . $act . '/' . $param . '/' . $y . '/' . $m . '/pickup/');
		
		// UAの時はwhere句に追記
		if ($param === 'ua') {
			$where .= " or type = 'mobile' or type = 'game'";
		}
		
		// 端末機種の時
		elseif ($param === 'device') {
			self::device();
		}
		
		// メソッド名、where句を返す
		return [$replace, $where];
		
	}
	
	//---------------------------------------------------------
	//  表示名の置換
	//---------------------------------------------------------
	
	public static function replacePage($vars) {
		
		// 表示名を返す
		return '<a href="' . JUMP_PATH . $vars['url'] . '" class="out" title="' . $vars['title'] . '">' . mb_strimwidth($vars['title'], 0, MAX_LEN, '...', 'UTF-8') . '</a>';
		
	}
	
	//---------------------------------------------------------
	//  表示名の置換
	//---------------------------------------------------------
	
	public static function replaceOptDir($vars) {
		
		// 表示名を返す
		return preg_replace('/http.?:\/\/[^\/]*/', '', $vars['value']);
		
	}
	
	//---------------------------------------------------------
	//  表示名の置換
	//---------------------------------------------------------
	
	public static function replaceOptURL($vars) {
		
		// http://を削除
		$vars['title'] = preg_replace("/http.?:\/\/[^\/]*/", '', $vars['title']);
		
		// 表示名を返す
		return '<a href="' . JUMP_PATH . $vars['url'] . '" class="out">' . mb_strimwidth($vars['title'], 0, MAX_LEN, '...', 'UTF-8') . '</a>';
		
	}
	
	//---------------------------------------------------------
	//  リンクの設定
	//---------------------------------------------------------
	
	public static function replaceOptDomain($vars) {
		
		// 項目名のリンクを整形
		return '<a href="' . JUMP_PATH . 'https://' . $vars['value'] . '/" class="out" title="' . $vars['value'] . '">' . mb_strimwidth($vars['value'], 0, MAX_LEN, '...', 'UTF-8') . '</a>';
		
	}
	
	//---------------------------------------------------------
	//  表示名の置換
	//---------------------------------------------------------
	
	public static function replaceOptExists($vars) {
		
		// 項目名を返す
		return $GLOBALS['menu']['exists'][$vars['value']];

	}
	
	//---------------------------------------------------------
	//  表示名の置換
	//---------------------------------------------------------
	
	public static function replaceVisit($vars) {
		
		// 項目名を返す
		return $vars['value'] . '回目';
		
	}
	
	//---------------------------------------------------------
	//  表示名の置換
	//---------------------------------------------------------
	
	public static function replaceRepeat($vars) {
		
		// 項目名を返す
		return $GLOBALS['menu']['repeat'][$vars['value']];

	}
	
	//---------------------------------------------------------
	//  表示名の置換
	//---------------------------------------------------------
	
	public static function replaceHostDomain($vars) {
		
		// 別名で項目名を保持
		$value = $vars['value'];
		
		// 「unknown」の時は何もしない
		if ($value === 'unknown') {
			return 'unknown';
		}
		
		// 所属名が存在する時は追記
		$plus = (isset($GLOBALS['name'][$value])) ? ' (' . $GLOBALS['name'][$value] . ')' : '';
		
		// 項目名のリンクを整形
		return '<a href="' . JUMP_PATH . 'https://www.' . $value . '/" class="out">' . $value . '</a>' . $plus;
		
	}
	
	//---------------------------------------------------------
	//  表示名の置換
	//---------------------------------------------------------
	
	public static function replaceWorld($vars) {
		
		// 別名で項目名を保持
		$value = $vars['value'];
		
		// ドメインを「.」で分割
		$domains = explode('.', $value);
		
		// 末尾の要素を切り出し（Top Level Domain）
		$tld = array_pop($domains);
		
		// 所属名が存在する時は追記
		$plus = (isset($GLOBALS['name'][$tld])) ? ' (' . $GLOBALS['name'][$tld] . ')' : '';
		
		// 項目名のリンクを整形
		return '<a href="' . JUMP_PATH . 'https://www.' . $value . '/" class="out">' . $value . '</a>' . $plus;
		
	}
	
	//---------------------------------------------------------
	//  リンクの設定
	//---------------------------------------------------------
	
	public static function replaceSearchWord($vars) {
		
		// 表示名を返す
		return '<a href="' . JUMP_PATH . 'https://www.google.com/' . '::' . preg_replace('/"/', "'", $vars['value']) . '" class="out">' . $vars['value'] . '</a>';
		
	}
	
	//---------------------------------------------------------
	//  表示名の置換
	//---------------------------------------------------------
	
	public static function replaceOS($vars) {
		
		// 値を別名で保持
		$value = $vars['value'];
		
		// 愛称が存在するときはUAに追記
		if (isset($GLOBALS['name'][$value])) {
			$value = $GLOBALS['name'][$value];
		}
		
		// UAを返す
		return $value;
		
	}
	
	//---------------------------------------------------------
	//  リンクの設定
	//---------------------------------------------------------
	
	public static function replaceOptRobot($vars) {
		
		// Mozilla互換文字列を削除
		$ua = preg_replace('/(Mozilla\/\d\.\d )/', '', $vars['value']);
		
		// UA文字列を抽出
		if (preg_match('/compatible; ([^\;]+)/', $ua, $m)) {
			$ua = $m[1];
		} elseif (preg_match('/\(([^\;+]+)( \d{1,2}\.\d)\)/', $ua, $m)) {
			$ua = $m[1] . $m[2];
		} elseif (preg_match('/\([^)]+\)([^(]+)/', $ua, $m)) {
			$ua = $m[1];
		} elseif (preg_match('/([^(]+)/A', $ua, $m)) {
			$ua = $m[1];
		} elseif (preg_match('/\(([^\;+]+)/A', $ua, $m)) {
			$ua = $m[1];
		}
		
		// バージョン表記を整形する
		$ua = preg_replace('/\/v{0,1}(\d)/', " $1", $ua);
		
		// 無関係の文字列があれば削除
		$ua = preg_replace('/ ?[\+\,\;\)].*?$| .+@.+|Gecko [\d]+ /', '', $ua);
		
		// 文字数を制限
		$ua = mb_strimwidth($ua, 0, MAX_LEN, '...', 'UTF-8');
		
		// URLが含まれている時はリンクを張る
		if (preg_match("/(http:[^\);,&]*)/", $vars['value'], $m)) {
			$ua = '<a href="' . JUMP_PATH . $m[1] . '" class="out">' . $ua . '</a>';
		}
		
		// UAを返す
		return $ua;
		
	}
	
	//---------------------------------------------------------
	//  リンクの設定
	//---------------------------------------------------------
	
	public static function replaceGroup($vars) {
		
		// 表示名を返す
		return '<a href="' . ARRANGE_PATH . $vars['value'] . '">' . $vars['value'] . '</a>';
		
	}
	
	//---------------------------------------------------------
	//  フィルタリング
	//---------------------------------------------------------
	
	public static function optFilter($db, $param, $opt, $results, $totalCount, $paramTable) {
		
		// 変数を初期化
		$optCounts = [];
		
		// ピックアップフィルターの時
		if ($opt === 'pickup') {
			$pickup = $GLOBALS['args']['pickup'];
		}
		
		// ディレクトリフィルターの時
		elseif ($opt === 'dir') {
			$dirNames = self::getDirNames($db);
		}
		
		// リンク元有無フィルターの時
		if ($opt === 'exists') {
			$optCounts = self::getExistsCounts($db, $paramTable, $totalCount);
		}
		
		// 訪問回数の時
		elseif ($opt === 'repeat') {
			$optCounts = self::getRepeatCounts($db, $paramTable, $totalCount);
		}
		
		// リンク元有無フィルター以外の時
		else {
			
			// フィルタリングループ
			while ($rec = $db->fetch($results)) {
				
				// 項目名を取得
				$value = $rec['value'];
				
				// カウント数を取得
				$count = $rec['count'];
				
				// 項目名を配列に分割
				$values = preg_split('/×| x |\/| /', $value);
				
				// 項目名を別名で保持
				$optValue = $value;
				
				// リンク元ドメインフィルターの時
				if ($opt === 'domain') {
					
					// ドメイン名を設定
					if (isset($values[2])) {
						$optValue = $values[2];
					}
					
					// ドメインが無い時は次へ
					else {
						continue;
					}
					
				}
				
				// ディレクトリフィルターの時
				elseif ($opt === 'dir') {
					
					// ディレクトリ名を設定
					$optValue = (isset($dirNames[$value])) ? $dirNames[$value] : 'undefined';
					
				}
				
				// 端末機種の時
				elseif ($param === 'device') {
					
					// モデル名を取得
					$model = (isset($GLOBALS['name'][$value])) ? $GLOBALS['name'][$value] : $value;
					
					// 統合 or ピックアップフィルターの時
					if ($opt === 'group' || $opt === 'pickup') {
						
						// モデル名をスペースで分割
						$device = explode(' ', $model);
						
						// 統合の時
						if ($opt === 'group') {
							
							// 先頭の文字列を設定
							$optValue = $device[0];
							
						}
						
						// ピックアップフィルターの時
						else {
							
							// 該当しない時は次へ
							if ($pickup !== $device[0]) {
								continue;
							}
							
							// モデル名を設定
							$optValue = $model;
							
						}
						
					}
					
					// 通常の時
					elseif ($opt === 'model') {
						
						// モデル名を設定
						$optValue = $model;
						
					}
					
				}
				
				// ピックアップフィルターの時
				elseif ($opt === 'pickup') {
					
					// Linuxの時
					if ($pickup === 'Linux' && isset($values[1]) and $values[1] === 'Linux') {
						$values[0] = 'Linux';
					}
					
					// Fedora, Ubuntu, CentOSの時
					elseif ($pickup === 'Linux' && preg_match('/Fedora|Ubuntu|CentOS/', $values[0])) {
						$values[0] = 'Linux';
					}
					
					// 項目に一致しない時は次へ
					if ($pickup !== $values[0]) {
						continue;
					}
					
				}
				
				// その他の時
				else {
					
					// 項目名配列が1つの時
					if (count($values) == 1) {
						$optValue = (!preg_match('/Fedora|Ubuntu|CentOS/', $values[0])) ? $values[0] : 'Linux';
					}
					
					// height及びOS統合フィルターの時
					elseif ($opt === 'height' || $values[1] === 'Linux') {
						$optValue = $values[1];
					}
					
					// それ以外の時
					else {
						$optValue = $values[0];
					}
					
				}
				
				// 配列のデータが存在する時はカウントを増加
				if (isset($optCounts[$optValue])) {
					$optCounts[$optValue] += $count;
				}
				
				// 配列のデータが存在しない時はカウントを配列に設定
				else {
					$optCounts[$optValue] = $count;
				}
				
			}
			
		}
		
		// ピックアップの時は合計値を算出
		if ($opt === 'pickup' || $opt === 'exists' || $opt === 'mobile' || $opt === 'repeat') {
			$totalCount = array_sum($optCounts);
		}
		
		// 降順にソート
		arsort($optCounts);
		
		// 総数を取得
		$allRows = count($optCounts);
		
		// データを返す
		return [$optCounts, $totalCount, $allRows];
		
	}
	
	//---------------------------------------------------------
	//  訪問回数データ取得
	//---------------------------------------------------------
	
	public static function getRepeatCounts($db, $paramTable, $totalCount) {
		
		// 変数を初期化
		$optCounts = [];
		
		// クエリーを作成
		$query = "select count from $paramTable where type = 'visit_count' and value = 1;";
		
		// クエリーを実行
		$count = $db->queryFetch($query, 'count');
		
		// カウント数が存在する時は配列に設定
		if ($count) {
			$optCounts['first'] = $count;
			$optCounts['repeat'] = $totalCount - $count;
		}
		
		// データ配列を返す
		return $optCounts;
		
	}
	
	//---------------------------------------------------------
	//  リンク元有無データ取得
	//---------------------------------------------------------
	
	public static function getExistsCounts($db, $paramTable, $totalCount) {
		
		// 変数を初期化
		$optCounts = [];
		
		// 詳細ログテーブル名を取得
		$visitTable = $GLOBALS['config']['table']['visit'];
		
		// クエリーを作成
		$query1 = "select count(seq) as count from $visitTable where ua_type != 'Robot' and referrer = '';";
		
		// リンク元無しを取得
		$count1 = $db->queryFetch($query1, 'count');
		
		// 1件以上の時は配列に設定
		if ($count1) {
			$optCounts['no_ref'] = $count1;
		}
		
		// クエリーを作成
		$query2 = "select count(seq) as count from $visitTable where ua_type != 'Robot' and referrer != '' and search_words = '';";
		
		// リンク元有り（通常リンク）を算出
		$count2 = $db->queryFetch($query2, 'count');
		
		// 1件以上の時は配列に設定
		if ($count2) {
			$optCounts['normal'] = $count2;
		}
		
		// クエリーを作成
		$query3 = "select count(seq) as count from $visitTable where ua_type != 'Robot' and referrer != '' and search_words != '';";
		
		// リンク元有り（検索エンジン）を算出
		$count3 = $db->queryFetch($query3, 'count');
		
		// 1件以上の時は配列に設定
		if ($count3) {
			$optCounts['search'] = $count3;
		}
		
		// データ配列を返す
		return $optCounts;
		
	}
	
	//---------------------------------------------------------
	//  dirデータ取得
	//---------------------------------------------------------
	
	public static function getDirNames($db) {
		
		// 変数を初期化
		$names = [];
		
		// データテーブル名を設定
		$pageTable = $GLOBALS['config']['table']['page'];
		
		// クエリーを作成
		$query = "select id, url from $pageTable order by id;";
		
		// クエリーを実行
		$results = $db->query($query);
		
		// フィルタリングループ
		while ($rec = $db->fetch($results)) {
			
			// データを取得
			$id = $rec['id'];
			$url = $rec['url'];
			
			// 「/」でURLを分割
			$urls = explode('/', $url);
			
			// ディレクトリ名を取得
			$url = (!array_pop($urls)) ? $url : dirname($url) . '/';
			
			// バックスラッシュを削除
			//$url = stripcslashes($url);
			
			// IDをキーとした連想配列に設定
			$names[$id] = $url;
			
		}
		
		// データ配列を返す
		return $names;
		
	}
	
	//---------------------------------------------------------
	//  自身のドメイン名を取得
	//---------------------------------------------------------
	
	public static function getSelfDomains($db) {
		
		// 配列を初期化
		$domains = [];
		
		// テーブル名を設定
		$pageTable = $GLOBALS['config']['table']['page'];
		
		// クエリーを作成
		$query = "select url from $pageTable limit 100;";
		
		// クエリーを実行
		$results = $db->query($query);
		
		// 詳細ログを表示するループ
		while ($rec = $db->fetch($results)) {
			
			// URLをパース
			$urls = parse_url($rec['url']);
			
			// ドメイン名を取得
			$host = $urls['scheme'] . '://' . $urls['host'];
			
			// ドメイン名を配列に設定
			$domains[$host] = true;
			
		}
		
		// ドメイン名を返す
		return array_keys($domains);
		
	}
	
}

