<?php

class Version {
	
	//---------------------------------------------------------
	//  コントロール設定
	//---------------------------------------------------------
	
	public static function control() {
		
		// コントロール設定を返す
		return [true, false, 'Header', 'Footer'];
		
	}
	
	//---------------------------------------------------------
	//  バージョン情報を表示
	//---------------------------------------------------------
	
	public static function execute() {
		
		// DBクラスを取得
		$db = $GLOBALS['object']['db'];
		
		// テンプレートクラスを取得
		$tmpl = $GLOBALS['object']['tmpl'];
		
		// テンプレートファイルを読み込み
		$html = $tmpl->read('version.htm', false);
		
		// スクリプトバージョンファイルを解析
		$version = parse_ini_file(WORK_DIR . '/templates/ini/version.ini');
		
		// スクリプトバージョンを取得
		$vars['scrVer'] = $version['version'];
		
		// PHPバージョンを取得
		$vars['phpVer'] = PHP_VERSION;
		
		// DBバージョンを取得
		$vars['sqliteVer'] = $db->version();
		
		// PHP実行環境を取得
		$vars['phpSapi'] = PHP_SAPI;
		
		// Webサーバー名を取得
		$vars['serverSoftware'] = (isset($_SERVER['SERVER_SOFTWARE'])) ? $_SERVER['SERVER_SOFTWARE'] : 'unkown';
		
		// リクエストプロトコルを取得
		$vars['serverProtocol'] = (isset($_SERVER['SERVER_PROTOCOL'])) ? $_SERVER['SERVER_PROTOCOL'] : 'unkown';
		
		// メインテンプレートを出力
		$tmpl->show($html, $vars);
		
	}
	
}

