<?php

class Login {
	
	//---------------------------------------------------------
	//  ログイン処理
	//---------------------------------------------------------
	
	public static function execute() {
		
		// 変数を初期化
		$username = '';
		$password = '';
		
		// フォームデータが存在する時
		if (isset($_POST['login'])) {
			
			// ユーザーIDを取得
			$username = (isset($_POST['username'])) ? md5($_POST['username']) : '';
			
			// パスワードを取得
			$password = (isset($_POST['password'])) ? md5($_POST['password']) : '';
			
		}
		
		// Cookieが存在する時
		elseif (isset($_COOKIE['lunalysLogin'])) {
			
			// Cookieをパース
			parse_str($_COOKIE['lunalysLogin'], $results);
			
			// ユーザーIDを取得
			$username = (isset($results['username'])) ? $results['username'] : '';
			
			// パスワードを取得
			$password = (isset($results['password'])) ? $results['password'] : '';
			
		}
		
		// 管理者の時は何もしない
		if ($username === md5($GLOBALS['config']['login']['username']) && $password === md5($GLOBALS['config']['login']['password'])) {
			
		}
		
		// 一般ユーザーの時は管理者フラグをリセット
		elseif (isset($GLOBALS['config']['account']) && self::isValid($username, $password)) {
			$GLOBALS['isAdmin'] = false;
		}
		
		// IDもしくはPWが一致しない時はログインフォームを表示
		else {
			exit(self::showForm());
		}
		
		// Cookieを発行
		self::saveCookie('lunalysLogin', "username=$username&password=$password");
		
	}
	
	//---------------------------------------------------------
	//  Cookieを発行
	//---------------------------------------------------------
	
	public static function saveCookie($name, $value) {
		
		// PHPエラーが出力済の時は終了
		if (headers_sent()) {
			return;
		}
		
		// 有効期限を設定（1年間）(60 * 60 * 24 * 365)
		$expires = $_SERVER['REQUEST_TIME'] + 31536000;
		
		// 対象ドメイン
		$domain = $_SERVER['HTTP_HOST'];
		
		// PHP 7.3 以上の時
		if (version_compare(PHP_VERSION, '7.3.0') >= 0) {
			
			// Cookieを発行（PHP 7.3以上）
			setcookie($name, $value, [
				'expires' => $expires,
				'path' => '/',
				'domain' => $domain,
				'samesite' => 'Lax',
				'secure' => false,
				'httponly' => false,
			]);
			
		}
		
		// PHP 7.3 未満の時
		else {
			setcookie($name, $value, $expires, '/', $domain);
		}
		
	}
	
	//---------------------------------------------------------
	//  有効なID＆PWかバリデート
	//---------------------------------------------------------
	
	private static function isValid($username, $password) {
		
		// 5回ループ
		for ($j = 1; $j < 6; ++$j) {
			
			// 配列のキーを設定
			$key1 = 'username' . $j;
			$key2 = 'password' . $j;
			
			// 設定配列に存在しない時は次へ
			if (!isset($GLOBALS['config']['account'][$key1])) {
				continue;
			}
			
			// ユーザー名とパスワードが一致した場合はtrueを返す
			elseif ($username === md5($GLOBALS['config']['account'][$key1]) && $password === md5($GLOBALS['config']['account'][$key2])) {
				return true;
			}
			
		}
		
		// falseを返す
		return false;
		
	}
	
	//---------------------------------------------------------
	//  ログインフォーム表示
	//---------------------------------------------------------
	
	public static function showForm() {
		
		// テンプレートクラスを取得
		$tmpl = $GLOBALS['object']['tmpl'];
		
		// テンプレートを読み込み
		$html = $tmpl->read('login.htm', false);
		
		// URLパスを設定
		$vars['path'] = PATH;
		
		// URLパスディレクトリを設定
		$vars['pathDir'] = PATH_DIR;
		
		// ユーザー名に空欄を設定
		$vars['username'] = '';
		
		// パスワードに空欄を設定
		$vars['password'] = '';
		
		// テンプレートを出力
		$tmpl->show($html, $vars);
		
	}
	
}

