<?php

class Date {
	
	//---------------------------------------------------------
	//  現在時刻の取得
	//---------------------------------------------------------
	
	public function nowDate() {
		
		// グリニッジ標準時との時差を取得
		$gmtDiff = (isset($GLOBALS['config']['framework']['gmtDiff'])) ? $GLOBALS['config']['framework']['gmtDiff'] : 9;
		
		// 現在時刻を返す
		return explode(' ', gmdate('Y m d D H i s', $_SERVER['REQUEST_TIME'] + $gmtDiff * 60 * 60));
		
	}
	
	//---------------------------------------------------------
	//  前日の日付取得
	//---------------------------------------------------------
	
	public function backDate($days = 1) {
		
		// グリニッジ標準時との時差を取得
		$gmtDiff = (isset($GLOBALS['config']['framework']['gmtDiff'])) ? $GLOBALS['config']['framework']['gmtDiff'] : 9;
		
		// 先日日付を返す
		return explode(' ', gmdate('Y m d', strtotime("-$days days") + $gmtDiff * 60 * 60));
		
	}
	
	//---------------------------------------------------------
	//  月の最終日の取得
	//---------------------------------------------------------
	
	public function monthDays($y, $m) {
		
		// 日付をintにキャスト
		$y = (int) $y;
		$m = (int) $m;
		
		// 2月以外の時
		if ($m !== 2) {
			
			// 配列を定義
			$md = [
				1 => 31,
				2 => 28,
				3 => 31,
				4 => 30,
				5 => 31,
				6 => 30,
				7 => 31,
				8 => 31,
				9 => 30,
				10 => 31,
				11 => 30,
				12 => 31
			];
			
			// 値を返す
			return $md[$m];
			
		}
		
		// 2月の時
		else {
			
			// 閏年フラグを取得
			$yu = $y % 4;
			
			// 閏年の時は29を返す
			if ($yu === 0) {
				return 29;
			}
			
			// 閏年以外の時は28を返す
			else {
				return 28;
			}
			
		}
		
	}
	
	//---------------------------------------------------------
	//  年月日の曜日を取得
	//---------------------------------------------------------
	
	public function weekDay($y, $m, $d) {
		
		// 日付をintにキャスト
		$y = (int) $y;
		$m = (int) $m;
		$d = (int) $d;
		
		// 閏年用に年と月を調整
		if ($m === 1 || $m === 2) {
			--$y;
			$m += 12;
		}
		
		// 曜日コードを算出
		$wd = ($y + intval($y / 4) - intval($y / 100) + intval($y / 400) + intval((13 * $m + 8) / 5) + $d) % 7;
		
		// 配列を定義
		$enArray = ['sun', 'mon', 'tue', 'wed', 'thu', 'fri', 'sat'];
		$jaArray = ['日', '月', '火', '水', '木', '金', '土'];
		
		// 曜日を取得
		$en = $enArray[$wd];
		$ja = $jaArray[$wd];
		
		// 曜日を返す
		return [$wd, $en, $ja];
		
	}
	
}

